#ifndef __EXT_API_DEFINES_INCLUDED__
#define __EXT_API_DEFINES_INCLUDED__

#pragma once

// variable handles

typedef void* ZVAR;
typedef void* ZMAP;
typedef void* ZLIST;
typedef void* ZFORMAT;

// some selected variable type defines

#define VarID_void			1
#define VarID_var			2 // variant type, data is another ZVAR
#define VarID_bool			3
#define VarID_char			4
#define VarID_byte			5
#define VarID_short			6
#define VarID_int			7
#define VarID_int64			8
#define VarID_float			9
#define VarID_double		10
#define VarID_string		11
#define VarID_LPVOID		20
#define VarID_varlist		31
#define VarID_map			60
#define VarID_format		100
#define VarID_ComboSelector	302

// map type defines

#define MAP_Empty				0
#define MAP_BYTE				1
#define MAP_WORD				2
#define MAP_24bit				3
#define MAP_DWORD				4

#define MAP_DesignMap			10	// DM
#define MAP_Heightfield			20	// HF
#define MAP_TerrainNormals		30	// TN
#define MAP_AttributesMap		40	// AM
#define MAP_WaterMap			50	// WM

// pixel type structs

typedef struct {
	short int  Alt;		// exact altitude (in m) (-32k -> 32k)
	BYTE Peak;			// cone strength
	BYTE Frac;			// fractal strength
	BYTE Cliffs;		// cliff / plateau strength
	BYTE Erosion;
	BYTE Lakes;			// lake number / size
	BYTE Climate;
	BYTE SpecType;		// Mountain, Plateau, Volcano
	BYTE SpecParam;
} DesignMapPixel;

typedef struct {
	BYTE ClimateID;		// index of climate in group list
	BYTE LandTypeID;	// index of land type in climate
} AttributesPixel;

typedef struct {
	USHORT WaterID;	// identifies the body of water holding this pixel
	BYTE Type;
	float WaterLevel;
} WaterMapPixel;

#endif